#include<stdlib.h>
#include<stdio.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<arpa/inet.h>
#include<errno.h>
#include<string.h>
#include<netdb.h>
#include"barrier.h"

Barrier::Barrier()
{
  const char *val;
  debug=0;
  port=12000;
  if((val=getenv("DBG_BARRIER"))!=NULL)
  {
    debug=1;
  }

 
  if((val=getenv("BARRIER_FIRST_ID"))!=NULL)
  {
    id=atol(val);
  }
  if((val=getenv("BARRIER_WAIT_ON"))!=NULL)
  {
    waiton=atoi(val);
  }
  else
  {
    fprintf(stderr,"Barrier: BARRIER_WAIT_ON is not set - deactivating\n");
    waiton=0; // deactivating
  }
  if((host=getenv("BARRIER_HOST"))==NULL)
  {
    fprintf(stderr,"Barrier: BARRIER_HOST is not set - deactivating\n");
    waiton=0;
  }
  if((val=getenv("BARRIER_PORT"))!=NULL)
  {
    port=(short)atoi(val);
  }

  if(waiton==0) return;

  struct hostent* entry=gethostbyname(host);
  if(entry == NULL)
  {
    fprintf(stderr,"gethostbyname(%s:%d): Rechner %s nicht gefunden\n",
	    __FILE__,__LINE__,host);
    exit(1); // uebel uebel ...
  }
  addr.sin_family=AF_INET;
  memcpy(&(addr.sin_addr),entry->h_addr_list[0],entry->h_length);
  addr.sin_port = htons(port);
}

void Barrier::sync()
{
  char puffer[64];
  int s = socket(AF_INET,SOCK_STREAM,0);
  if(s<0) { perror("socket"); exit(1); }
  if(connect(s,(const sockaddr *)&addr,sizeof(addr))<0) { perror("connect"); exit(1); }
  snprintf(puffer,64,"BARRIER %d WAIT %d\n",id,waiton);
  int sl=strlen(puffer);
  int r=send(s,puffer,sl,0);
  if(r<strlen(puffer)) fprintf(stderr,"BARRIER: send: nur %d von %d \n",r,sl);
  if(r<0) perror("send");
  if(debug)
  {
    fprintf(stderr,"BARRIER: send: %s\n",puffer);
  }
  r=recv(s,puffer,64,0);
  if(r<0) perror("recv");
  puffer[r-1]='\0';
  if(debug)
  {
    fprintf(stderr,"BARRIER: recv %s\n",puffer);
  }
  close(s);
  id++;
}

#ifdef BARRIER_TEST
main()
{
  Barrier barrier;

  barrier.sync();
}
#endif
