#include<stdio.h>
#include<stdlib.h>
#include<assert.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<arpa/inet.h>
#include<errno.h>
#include<string.h>

static char errmsg[256];

struct vinfo
{
  int fd;
  long bid;
  int  sollanz;
};

class Verbindungen
{
  int anz;
  vinfo v[64];
public:
  Verbindungen() { anz=0; }
  void add(int s); 
  int genset(fd_set *ret);
  void Verbindungen::readrequest(fd_set *in);
};

void Verbindungen::add(int s) 
{
  int i=0;
  assert(anz<64);
  while(i<anz && v[i].fd!=-1) i++;
  
  v[i].fd=s;
  v[i].bid=0;
  v[i].sollanz=0;
  if(i==anz)
  {
    anz++;
  }
  fprintf(stderr,"Added on %d\n",i);
}
int Verbindungen::genset(fd_set *ret)
{
  int max=0;
  for(int i=0;i<anz;i++)
  {
    if(v[i].fd !=-1)
    {
      if(v[i].fd > max) max=v[i].fd;
      FD_SET(v[i].fd,ret);
    }
  }
  return max;
}

void Verbindungen::readrequest(fd_set *in)
{
  char puffer[64+1];
  int i;
  for(i=0;i<anz;i++)
  {
    if(v[i].fd!=-1 && FD_ISSET(v[i].fd,in))
    {
      int r=read(v[i].fd,puffer,64);
      puffer[r]='\0';
      if(r<0) { perror("read"); }
      if(r>0)
      {
	if(sscanf(puffer,"BARRIER %d WAIT %d",&(v[i].bid),&(v[i].sollanz))==2)
	{
	  int j;
	  fprintf(stderr,"%d:Barrier %d warte auf %d\n",i,v[i].bid,
		         v[i].sollanz);
	  int found=0;
	  int bid=v[i].bid;
	  for(j=0;j<anz;j++)
	  {
	    if(v[j].bid==bid) found++;
	  }
	  if(found==v[i].sollanz)
	  {
	    fprintf(stderr,"Barrier %d ready\n",v[i].bid);
	    for(j=0;j<anz;j++)
	    {
	      if(v[j].bid==bid)
	      {
		write(v[j].fd,"GO\n",3);
		shutdown(v[j].fd,2);
		v[j].fd=-1;v[j].bid=0;
	      }
	    }
	  }
	  if(found > v[i].sollanz)
	  {
	    fprintf(stderr,"found > sollanz : Das gibt es nicht \n");
	  }
	}
	else
	{
	  fprintf(stderr,"Quatsch auf %d:%s\n",i,puffer);
	}
      }
      else 
      {
	shutdown(v[i].fd,2);
	v[i].fd=-1;
      }
    }
  }
}

int main(int argc,char **argv)
{
  Verbindungen verb;
  short port=12000;
  struct sockaddr_in myaddr;
  struct sockaddr_in kundenaddr;
  socklen_t kundenaddrlen = sizeof(kundenaddr);
  
  int s0;
  memset((char *)&myaddr,'\0',sizeof(struct sockaddr_in));
  if(argv[1]!=NULL) port=atoi(argv[1]);
  myaddr.sin_family = AF_INET;
  myaddr.sin_addr.s_addr = INADDR_ANY;
  myaddr.sin_port = htons(port);


  if((s0 = socket(AF_INET,SOCK_STREAM,0)) < 0)
  {   
    sprintf(errmsg,"socket (%s:%d):",__FILE__,__LINE__);
    perror(errmsg);
    exit(1);
  }

   if(bind(s0,(struct sockaddr *)&myaddr,sizeof(struct sockaddr_in)) < 0)
   {
      sprintf(errmsg,"bind (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }
   
   listen(s0,10);
   
   fd_set rset;

   
   while(1)
   {
     FD_ZERO(&rset);
     FD_SET(s0,&rset);
     int max=verb.genset(&rset);
     if(max<s0) max=s0;
     fprintf(stderr,"maxfd=%d\n",max);
     int r=select(max+1,&rset,NULL,NULL,NULL);
     if(r<0)
     {
       perror("select");exit(1);
     } 
     if(FD_ISSET(s0,&rset))
     {
       int sneu=accept(s0,(struct sockaddr *)&kundenaddr,&kundenaddrlen);
       if(sneu<0) { perror("accept");exit(1); }
       assert(kundenaddr.sin_family == AF_INET);
       fprintf(stderr," %s Port: %d\n",inet_ntoa(kundenaddr.sin_addr),
	       ntohs(kundenaddr.sin_port));
       verb.add(sneu);
     }
     else 
     {
       verb.readrequest(&rset);
     }
   }
}







